
#ifndef __tagreader_h__
#define __tagreader_h__

#include <string>
#include <map>

namespace chm {

/** @internal */
class tagreader {
public:
  struct tagstruct {
    std::string tag;
    std::string text;
    std::map<std::string, std::string> elems;
    int tag_level;
    int total_level;
  };
  tagreader (const std::string& data);

  tagstruct get_next ();
  bool has_next () const { return pos != data.end(); }
  bool skip_to (const std::string& tagname);

private:
  std::string data;
  std::string::iterator pos;
  size_t level;
  std::map<std::string, int> tag_levels;
};

}

#endif // __tagreader_h__

